Unit afh7e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure afh7e(var IA :Array of Integer; var JA :Array of Integer;
                var AN :Array of Extended; var AD :Array of Extended;
                N :Integer; var IU :Array of Integer;
                var JU :Array of Integer; var UN :Array of Extended;
                var DI :Array of Extended; var IP :Array of Integer;
                var IUP :Array of Integer);

implementation

procedure afh7e(var IA :Array of Integer; var JA :Array of Integer;
                var AN :Array of Extended; var AD :Array of Extended;
                N :Integer; var IU :Array of Integer;
                var JU :Array of Integer; var UN :Array of Extended;
                var DI :Array of Extended; var IP :Array of Integer;
                var IUP :Array of Integer);
var
J,I,IH,IUA,IUB,L,IAA,IAB,LAST,LN,IUC,IUD,JJ,L1 :Integer;
UM :Extended;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130;
begin

{           - }
{             }
{          A,  }
{        RR(U)U.     U  }
{             RR(U)O. }


{   IA, JA, AN, AD -      - }
{                     A   RR(U)U; }

{                N -   A (: ); }

{           IU, JU -    U   RR(U)O; }

{               UN -     }
{                    ,     - }
{                       U    }
{                     ; }

{               DI -     - }
{                      N,     }
{                     ,    - }
{                     D ; }

{          IP, IPU -     N,  }
{                         }


{            IP }

for J:=1 to N do
 begin
_10:
  IP[J-1] := 0;
 end;

{            A  U }

for I:=1 to N do
 begin
  IH := I+1;
  IUA := IU[I-1];
  IUB := IU[IH-1]-1;

{         40,   I  U   }
{         }

  if ( IUB < IUA ) 
   then goto _40;

{           DI,  - }
{          I  U }

  for J:=IUA to IUB do
   begin
    L1 := JU[J-1];
_20:
    DI[L1-1] := 0.0e0;
   end;
  IAA := IA[I-1];
  IAB := IA[IH-1]-1;

{         40,   I  A   - }
{         }

  if ( IAB < IAA ) 
   then goto _40;
  for J:=IAA to IAB do
   begin
    L1 := JA[J-1];
_30:
    DI[L1-1] := AN[J-1];
   end;
_40:
  DI[I-1] := AD[I-1];

{          A,   - }
{         I }

  LAST := IP[I-1];
  if ( LAST = 0 ) 
   then goto _90;
  LN := IP[LAST-1];
_50:
  L := LN;
  LN := IP[L-1];
  IUC := IUP[L-1];
  IUD := IU[L+0]-1;

{           L - }
{       A      }

  UM := UN[IUC-1]*DI[L-1];
  for J:=IUC to IUD do
   begin
    JJ := JU[J-1];
_60:
    DI[JJ-1] := DI[JJ-1]-UN[J-1]*UM;
   end;
  UN[IUC-1] := UM;
  IUP[L-1] := IUC+1;

{         80,      }
{       L  U }

  if ( IUC = IUD ) 
   then goto _80;
  J := JU[IUC+0];
  JJ := IP[J-1];
  if ( JJ = 0 ) 
   then goto _70;
  IP[L-1] := IP[JJ-1];
  IP[JJ-1] := L;
  goto _80;
_70:
  IP[J-1] := L;
  IP[L-1] := L;
_80:
  if ( L <> LAST ) 
   then goto _50;

{       ,    I,   }

_90:
  DI[I-1] := 1.0e0/DI[I-1];
  if ( IUB < IUA ) 
   then goto _120;

{         UN    I }

  for J:=IUA to IUB do
   begin
    L1 := JU[J-1];
_100:
    UN[J-1] := DI[L1-1];
   end;

{             }

  J := JU[IUA-1];
  JJ := IP[J-1];
  if ( JJ = 0 ) 
   then goto _110;
  IP[I-1] := IP[JJ-1];
  IP[JJ-1] := I;
  goto _120;
_110:
  IP[J-1] := I;
  IP[I-1] := I;
_120:
  IUP[I-1] := IUA;
_130:
 end;
end;

end.
